<!-- This example requires Tailwind CSS v2.0+ -->
<template>
    <Listbox as="div" v-model="selected" class='w-full'>
        <ListboxLabel class="block text-sm font-medium text-gray-700">{{ label }}</ListboxLabel>
        <div class="mt-1 relative">
            <ListboxButton class="text-lg py-4 font-mont block w-full pr-10 border-b border-l-0 border-r-0 border-t-0 border-xmas-olive focus:outline-none focus:ring-0 focus:border-none sm:text-sm text-left">
                <span class="block truncate">{{ selected.name }}</span>
                <span class="absolute inset-y-0 right-0 flex items-center pr-2 pointer-events-none">
                    <SelectorIcon class="h-5 w-5 text-gray-400" aria-hidden="true" />
                </span>
            </ListboxButton>

            <transition leave-active-class="transition ease-in duration-100" leave-from-class="opacity-100" leave-to-class="opacity-0">
                <ListboxOptions class="absolute z-10 mt-1 w-full bg-white shadow-lg max-h-60 rounded-md py-1 text-base ring-1 ring-black ring-opacity-5 overflow-auto focus:outline-none sm:text-md">
                    <ListboxOption as="template" v-for="option in options" :key="option.id" :value="option" v-slot="{ active, selected }">
                        <li :class="[active ? 'text-white bg-xmas-olive' : 'text-gray-900', 'select-none relative py-4 cursor-pointer pl-3 pr-9']">
                            <span :class="[selected ? 'font-semibold' : 'font-normal', 'block truncate']">
                                {{ option.name }}
                            </span>

                            <span v-if="selected" :class="[active ? 'text-white' : 'text-xmas-olive', 'absolute inset-y-0 right-0 flex items-center pr-4']">
                                <CheckIcon class="h-5 w-5" aria-hidden="true" />
                            </span>
                        </li>
                    </ListboxOption>
                </ListboxOptions>
            </transition>
        </div>
    </Listbox>
</template>

<script>
import { ref } from 'vue'
import { Listbox, ListboxButton, ListboxLabel, ListboxOption, ListboxOptions } from '@headlessui/vue'
import { CheckIcon, SelectorIcon } from '@heroicons/vue/solid'

export default {
    props: [
        'modelValue', 'label', 'options'
    ],
    data() {
        return {
            content: this.modelValue,
        }
    },
    methods: {        
        handleInput (e) {
            this.content = e;
            this.$emit('update:modelValue', this.content)
        },
    },
    components: {
        Listbox,
        ListboxButton,
        ListboxLabel,
        ListboxOption,
        ListboxOptions,
        CheckIcon,
        SelectorIcon,
    },
    setup(props) {
        const selected = ref(props.options[0])
        const options = props.options

        return {
            options,
            selected,
        }
    },
    watch: {
        selected(value) {
            this.handleInput(value)
        }
    }
}
</script>